;/* BXB.INC */

; 
; Include files
; 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\oleaut32.inc
    include \masm32\include\crtdll.inc
    include \masm32\include\fpu.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\oleaut32.lib
    includelib \masm32\lib\crtdll.lib
    includelib \masm32\lib\fpu.lib

;----------------------------------
;  PROTO  PROTO  PROTO  PROTO 
; 
    Main      proto
    copystrng_bffr proto
    copystrng proto
    catstrng  proto
    chrstr    proto
    leftstr   proto
    rightstr  proto
    mid_str   proto
    spacestr  proto
    strsIval  proto
    strsFval  proto
    stringstr proto
    inkeystr  proto
    inputstr  proto
    wherexy   proto
    reset_cursor proto
    get_sys_date proto
    get_sys_time proto
    datestr   proto
    timestr   proto
    closeallfiles proto
    closeafile    proto
    getfilehandle proto
    clearstrng_bffr proto
    setupiobuffer   proto
    mkistr         proto
    mkdstr         proto
    mkqstr         proto
    lsetstr        proto
    rsetstr        proto
    Do_initialize   proto
    clear_allvars   proto
    clearstrvar  proto
    clearintvar  proto
    clearfltvar  proto
    clearLngstrng_bffr proto
    movstrng_bffr  proto
    readintstr   proto
    readfltstr   proto
    readQintstr  proto
    getfilelength  proto
    setcolortext   proto
    dimstrarray    proto
    getArryOffst proto

;  MACROS  MACROS  MACROS  MACROS 
; 

ifndef HIWORD
    _hiword macro a
        mov  eax, a
        shr  eax, 16
        and  eax, 0FFFFH
    endm
    HIWORD	equ  _hiword
endif
; 
;-----------------------------------------
ifndef LOWORD
    _loword macro a
        mov  eax, a
        and  eax, 0FFFFH
    endm
    LOWORD	equ  _loword
endif
; 
;-----------------------------------------
ifndef max
    max macro a,b
    LOCAL endmax
         mov  eax, a
         mov  ebx, b
         cmp  eax, ebx
         jge  endmax
         mov  eax, ebx
    endmax:
    endm
endif
; 
;-----------------------------------------
ifndef min
    min macro a,b
    LOCAL endmin
         mov  eax, a
         mov  ebx, b
         cmp  eax, ebx
         jle  endmin
         mov  eax, ebx
    endmin:
    endm
endif
; 
;-----------------------------------------
get MACRO a, b
    push edi
    push ebx
    mov edi, offset a
    mov eax, b
    mov ebx, 4
    mul bl
    add edi, eax
    mov eax, [edi]    ;  mov eax, szLabel+4
    pop ebx
    pop edi
ENDM
;------------------
;USE:
;       mov ndx, 3
;       get szLabel,ndx
;------------------
; 
;-----------------------------------------
_conditionl MACRO pa, pb, rc, rd
LOCAL isTrue
LOCAL isDone
  mov  eax, pa   ;tm.tmPitchAndFamily
  and  eax, pb   ;1     ; (tm.tmPitchAndFamily & 1 ? 3 : 2)
  jnz  isTrue
  ;
  mov  eax, rd   ;2
  jmp  isDone
isTrue:
  mov  eax, rc   ;3
isDone:
endm
CondtnlExp   equ _conditionl
;USE:
;  Conditionl var1, var2, result1, result2
; 
;-----------------------------------------
_sconditionl MACRO pa, pb, rc, rd
LOCAL isTrue
LOCAL isDone
  mov  eax, pa   ;0x08000000H & lParam ? "Down" : "Up")
  and  eax, pb   ;lParam
  jnz  isTrue
  ;
  mov  eax, rd   ;"Up"
  jmp  isDone
isTrue:
  mov  eax, rc   ;"Down"
isDone:
endm
sCondtnlExp   equ _sconditionl
;USE:
;  sConditionl var1, var2, str1, str2
; 
;-----------------------------------------
print MACRO Quoted_Text:VARARG
   LOCAL Txt
      .data
          Txt db Quoted_Text,0
      .code
        invoke StdOut,ADDR Txt
ENDM
; 
;-----------------------------------------
printstr    MACRO   stringVar
    invoke StdOut,ADDR stringVar    ; printstr astring
ENDM
; 
;-----------------------------------------
printvar    MACRO   reg
    invoke StdOut, reg              ; printstr astring
ENDM
; 
;-----------------------------------------
cls     MACRO
    invoke ClearScreen            ; CLS
ENDM
; 
;-----------------------------------------
; 
;-----------------------------------------


;  STRUCTURES  STRUCTURES  STRUCTURES 
; 


;  EQUATES  EQUATES  EQUATES  EQUATES 
; 
ifndef BUFFR_SIZ
    BUFFR_SIZ       equ     128
endif
ifndef BUFSIZE
    BUFSIZE         equ     256
endif
ifndef MBUFSIZE
    MBUFSIZE        equ     65535
endif

NUM_ATTRIB    equ     15

;##########################################################################
;  DATA  DATA  DATA  DATA 
.data
; CONSTANT ASSIGNMENTS
ff          db  12,0
lf          db  13,10,0     ; line feed
tab         db  9,0         ; tab
n_          dd  10          ; newline
x_          dd  0           ; any character
_Altern_$	DB  'wb+',0      ; alternate I/O Mode
Lprint$     db  'lpt1',0    ; for LPRINT
Lprnmode$   db  'w',0       ; for LPRINT

; DO NOT DELETE
